       IDENTIFICATION DIVISION.
       PROGRAM-ID.    OBFDATR1.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2019 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy and modify this software for any      *
      * non-commercial purpose and without fee is hereby granted,     *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used in *
      * any advertising or publicity pertaining to the use of the     *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *****************************************************************
      *
      *****************************************************************
      * Source Member: DATOBFC1.CBL
      * Copy Files:    QQSMREC1.CPY
      *****************************************************************
      *
      * DATOBFC2 - Call DATOBFC2 to get a record of customer
      *            information.
      *
      * EXECUTION or CALLING PROTOCOL
      * -----------------------------
      * Use standard COBOL call with USAGE and LINKAGE SECTION.
      *
      * DESCRIPTION
      * -----------
      * This program will read create name and address information.
      *
      *****************************************************************
      *
      * MAINTENANCE
      * -----------
      * 1997/02/27 Simmons, Created program.
      * 1997/02/27 Simmons, No changes to date.
      *
      *****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT FNAMEM01-FILE  ASSIGN TO       FNAMEM01
                  ORGANIZATION  IS SEQUENTIAL
                  ACCESS MODE   IS SEQUENTIAL
                  FILE STATUS   IS FNAMEM01-STATUS.

           SELECT FNAMEF01-FILE  ASSIGN TO       FNAMEF01
                  ORGANIZATION  IS SEQUENTIAL
                  ACCESS MODE   IS SEQUENTIAL
                  FILE STATUS   IS FNAMEF01-STATUS.

           SELECT LASTNAME-FILE  ASSIGN TO       LASTNAME
                  ORGANIZATION  IS SEQUENTIAL
                  ACCESS MODE   IS SEQUENTIAL
                  FILE STATUS   IS LASTNAME-STATUS.

           SELECT POSTCODE-FILE  ASSIGN TO       POSTCODE
                  ORGANIZATION  IS SEQUENTIAL
                  ACCESS MODE   IS SEQUENTIAL
                  FILE STATUS   IS POSTCODE-STATUS.

           SELECT STREET01-FILE  ASSIGN TO       STREET01
                  ORGANIZATION  IS SEQUENTIAL
                  ACCESS MODE   IS SEQUENTIAL
                  FILE STATUS   IS STREET01-STATUS.

      *****************************************************************
       DATA DIVISION.
       FILE SECTION.
       FD  FNAMEM01-FILE
           DATA RECORD    IS FNAMEM01-REC.
       01  FNAMEM01-REC.
           05  FNAMEM01-DATA-01    PIC X(32).

       FD  FNAMEF01-FILE
           DATA RECORD    IS FNAMEF01-REC.
       01  FNAMEF01-REC.
           05  FNAMEF01-DATA-01    PIC X(32).

       FD  LASTNAME-FILE
           DATA RECORD    IS LASTNAME-REC.
       01  LASTNAME-REC.
           05  LASTNAME-DATA-01    PIC X(32).

       FD  STREET01-FILE
           DATA RECORD    IS STREET01-REC.
       01  STREET01-REC.
           05  STREET01-DATA-01    PIC X(80).

       FD  POSTCODE-FILE
           DATA RECORD    IS POSTCODE-REC.
       COPY OBFPCDB1.

      *****************************************************************
       WORKING-STORAGE SECTION.
       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* OBFDATR1 '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(68)   value SPACES.
               10  MESSAGE-TEXT-2  pic X(188)  value SPACES.

       01  FNAMEM01-STATUS.
           05  FNAMEM01-STATUS-L   pic X.
           05  FNAMEM01-STATUS-R   pic X.
       01  FNAMEM01-EOF            pic X       value 'N'.
       01  FNAMEM01-OPEN-FLAG      pic X       value 'C'.

       01  FNAMEF01-STATUS.
           05  FNAMEF01-STATUS-L   pic X.
           05  FNAMEF01-STATUS-R   pic X.
       01  FNAMEF01-EOF            pic X       value 'N'.
       01  FNAMEF01-OPEN-FLAG      pic X       value 'C'.

       01  LASTNAME-STATUS.
           05  LASTNAME-STATUS-L   pic X.
           05  LASTNAME-STATUS-R   pic X.
       01  LASTNAME-EOF            pic X       value 'N'.
       01  LASTNAME-OPEN-FLAG      pic X       value 'C'.

       01  POSTCODE-STATUS.
           05  POSTCODE-STATUS-L   pic X.
           05  POSTCODE-STATUS-R   pic X.
       01  POSTCODE-EOF            pic X       value 'N'.
       01  POSTCODE-OPEN-FLAG      pic X       value 'C'.

       01  STREET01-STATUS.
           05  STREET01-STATUS-L   pic X.
           05  STREET01-STATUS-R   pic X.
       01  STREET01-EOF            pic X       value 'N'.
       01  STREET01-OPEN-FLAG      pic X       value 'C'.

       01  FNAMEM01-LRECL          pic 9(5)    value 00024.
       01  FNAMEF01-LRECL          pic 9(5)    value 00024.
       01  LASTNAME-LRECL          pic 9(5)    value 00024.
       01  POSTCODE-LRECL          pic 9(5)    value 00080.
       01  STREET01-LRECL          pic 9(5)    value 00080.

      *****************************************************************
      * The following buffers are used to create a four-byte status   *
      * code that may be displayed.                                   *
      *****************************************************************
       01  IO-STATUS.
           05  IO-STAT1            pic X.
           05  IO-STAT2            pic X.
       01  IO-STATUS-04.
           05  IO-STATUS-0401      pic 9     value 0.
           05  IO-STATUS-0403      pic 999   value 0.
       01  TWO-BYTES-BINARY        pic 9(4)  BINARY.
       01  TWO-BYTES-ALPHA         redefines TWO-BYTES-BINARY.
           05  TWO-BYTES-LEFT      pic X.
           05  TWO-BYTES-RIGHT     pic X.

       01  APPL-RESULT             pic S9(9)    comp.
           88  APPL-AOK            value 0.
           88  APPL-EOF            value 16.

       01  FOUR-DIGITS             pic 9(4)    value 0.

       01  DUMB-KEY.
           05  FILLER              pic X       value 'D'.
           05  DUMB-COUNT-11       pic 9(11)   value 0.

       01  VOWELS-UPPER    pic X(5)    value 'AEIOU'.
       01  VOWELS-LOWER    pic X(5)    value 'aeiou'.
       01  CONSTANTS-UPPER pic X(21)   value 'BCDFGHJKLMNPQRSTVWXYZ'.
       01  CONSTANTS-LOWER pic X(21)   value 'bcdfghjklmnpqrstvwxyz'.
       01  NUMBER-VALUE    pic X(10)   value '1234567890'.

       01  ONE-DIGIT       pic X       value SPACE.
       01  TEN-DIGITS      pic X(10)   value '0123456789'.
       01  SIZE-TABLE      pic X(18)   value '244342524132425143'.
       01  PTR-S           pic 9(3)    value 1.
       01  NBR-1-ALPHA.
           05  NBR-1-VALUE pic 9       value 1.

       01  VU-1            pic 9(3)    value 1.
       01  VL-1            pic 9(3)    value 1.
       01  CU-1            pic 9(3)    value 1.
       01  CL-1            pic 9(3)    value 1.
       01  NV-1            pic 9(3)    value 1.

       01  VU-2            pic 9(3)    value 5.
       01  VL-2            pic 9(3)    value 5.
       01  CU-2            pic 9(3)    value 21.
       01  CL-2            pic 9(3)    value 21.
       01  NV-2            pic 9(3)    value 10.

       01  FLIP-FLOP       pic X       value '0'.
       01  IDX-1           pic 9(3)    value 1.
       01  IDX-2           pic 9(3)    value 1.
       01  PTR-2           pic 9(3)    value 1.
       01  ADDR-NUMBER     pic X(9)    value SPACES.

       01  STATE-IDX       pic 9(3)    value 1.

       01  STATE-DATA.
           05  FILLER      pic X(15)   value 'Alabama        '.
           05  FILLER      pic X(15)   value 'Alaska         '.
           05  FILLER      pic X(15)   value 'Arizona        '.
           05  FILLER      pic X(15)   value 'Arkansas       '.
           05  FILLER      pic X(15)   value 'California     '.
           05  FILLER      pic X(15)   value 'Colorado       '.
           05  FILLER      pic X(15)   value 'Connecticut    '.
           05  FILLER      pic X(15)   value 'Delaware       '.
           05  FILLER      pic X(15)   value 'Florida        '.
           05  FILLER      pic X(15)   value 'Georgia        '.
           05  FILLER      pic X(15)   value 'Hawaii         '.
           05  FILLER      pic X(15)   value 'Idaho          '.
           05  FILLER      pic X(15)   value 'Illinois       '.
           05  FILLER      pic X(15)   value 'Indiana        '.
           05  FILLER      pic X(15)   value 'Iowa           '.
           05  FILLER      pic X(15)   value 'Kansas         '.
           05  FILLER      pic X(15)   value 'Kentucky       '.
           05  FILLER      pic X(15)   value 'Louisiana      '.
           05  FILLER      pic X(15)   value 'Maine          '.
           05  FILLER      pic X(15)   value 'Maryland       '.
           05  FILLER      pic X(15)   value 'Massachusetts  '.
           05  FILLER      pic X(15)   value 'Michigan       '.
           05  FILLER      pic X(15)   value 'Minnesota      '.
           05  FILLER      pic X(15)   value 'Mississippi    '.
           05  FILLER      pic X(15)   value 'Missouri       '.
           05  FILLER      pic X(15)   value 'Montana        '.
           05  FILLER      pic X(15)   value 'Nebraska       '.
           05  FILLER      pic X(15)   value 'Nevada         '.
           05  FILLER      pic X(15)   value 'New Hampshire  '.
           05  FILLER      pic X(15)   value 'New Jersey     '.
           05  FILLER      pic X(15)   value 'New Mexico     '.
           05  FILLER      pic X(15)   value 'New York       '.
           05  FILLER      pic X(15)   value 'North Carolina '.
           05  FILLER      pic X(15)   value 'North Dakota   '.
           05  FILLER      pic X(15)   value 'Ohio           '.
           05  FILLER      pic X(15)   value 'Oklahoma       '.
           05  FILLER      pic X(15)   value 'Oregon         '.
           05  FILLER      pic X(15)   value 'Pennsylvania   '.
           05  FILLER      pic X(15)   value 'Rhode Island   '.
           05  FILLER      pic X(15)   value 'South Carolina '.
           05  FILLER      pic X(15)   value 'South Dakota   '.
           05  FILLER      pic X(15)   value 'Tennessee      '.
           05  FILLER      pic X(15)   value 'Texas          '.
           05  FILLER      pic X(15)   value 'Utah           '.
           05  FILLER      pic X(15)   value 'Vermont        '.
           05  FILLER      pic X(15)   value 'Virginia       '.
           05  FILLER      pic X(15)   value 'Washington     '.
           05  FILLER      pic X(15)   value 'West Virginia  '.
           05  FILLER      pic X(15)   value 'Wisconsin      '.
           05  FILLER      pic X(15)   value 'Wyoming        '.
       01  STATE-TABLE-01  redefines STATE-DATA.
           05  STATE-TABLE pic X(15)   occurs 51 times.

       01  CAPITOL-CITIES.
           05  FILLER      pic X(15)   value 'Montgomery     '.
           05  FILLER      pic X(15)   value 'Juneau         '.
           05  FILLER      pic X(15)   value 'Phoenix        '.
           05  FILLER      pic X(15)   value 'LittleRock     '.
           05  FILLER      pic X(15)   value 'Sacramento     '.
           05  FILLER      pic X(15)   value 'Denver         '.
           05  FILLER      pic X(15)   value 'Hartford       '.
           05  FILLER      pic X(15)   value 'Dover          '.
           05  FILLER      pic X(15)   value 'Tallahassee    '.
           05  FILLER      pic X(15)   value 'Atlanta        '.
           05  FILLER      pic X(15)   value 'Honolulu       '.
           05  FILLER      pic X(15)   value 'Boise          '.
           05  FILLER      pic X(15)   value 'Springfield    '.
           05  FILLER      pic X(15)   value 'Indianapolis   '.
           05  FILLER      pic X(15)   value 'Des Moines     '.
           05  FILLER      pic X(15)   value 'Topeka         '.
           05  FILLER      pic X(15)   value 'Frankfort      '.
           05  FILLER      pic X(15)   value 'Baton Rouge    '.
           05  FILLER      pic X(15)   value 'Augusta        '.
           05  FILLER      pic X(15)   value 'Annapolis      '.
           05  FILLER      pic X(15)   value 'Boston         '.
           05  FILLER      pic X(15)   value 'Lansing        '.
           05  FILLER      pic X(15)   value 'Saint Paul     '.
           05  FILLER      pic X(15)   value 'Jackson        '.
           05  FILLER      pic X(15)   value 'Jefferson City '.
           05  FILLER      pic X(15)   value 'Helena         '.
           05  FILLER      pic X(15)   value 'Lincoln        '.
           05  FILLER      pic X(15)   value 'Carson City    '.
           05  FILLER      pic X(15)   value 'Concord        '.
           05  FILLER      pic X(15)   value 'Trenton        '.
           05  FILLER      pic X(15)   value 'Santa Fe       '.
           05  FILLER      pic X(15)   value 'Albany         '.
           05  FILLER      pic X(15)   value 'Raleigh        '.
           05  FILLER      pic X(15)   value 'Bismarck       '.
           05  FILLER      pic X(15)   value 'Columbus       '.
           05  FILLER      pic X(15)   value 'Oklahoma City  '.
           05  FILLER      pic X(15)   value 'Salem          '.
           05  FILLER      pic X(15)   value 'Harrisburg     '.
           05  FILLER      pic X(15)   value 'Providence     '.
           05  FILLER      pic X(15)   value 'Columbia       '.
           05  FILLER      pic X(15)   value 'Pierre         '.
           05  FILLER      pic X(15)   value 'Nashville      '.
           05  FILLER      pic X(15)   value 'Austin         '.
           05  FILLER      pic X(15)   value 'Salt Lake City '.
           05  FILLER      pic X(15)   value 'Montpelier     '.
           05  FILLER      pic X(15)   value 'Richmond       '.
           05  FILLER      pic X(15)   value 'Olympia        '.
           05  FILLER      pic X(15)   value 'Charleston     '.
           05  FILLER      pic X(15)   value 'Madison        '.
           05  FILLER      pic X(15)   value 'Cheyenne       '.
           05  FILLER      pic X(15)   value 'Montgomery     '.
           05  FILLER      pic X(15)   value 'Juneau         '.
           05  FILLER      pic X(15)   value 'Phoenix        '.
       01  CAPITOL-TABLE-01    redefines CAPITOL-CITIES.
           05  CAPITOL-TABLE   pic X(15)
                               occurs 51 times.

       01  LNAME-S1-DATA.
           05  FILLER         pic X(6)   value 'ally  '.
           05  FILLER         pic X(6)   value 'ous   '.
           05  FILLER         pic X(6)   value '      '.
           05  FILLER         pic X(6)   value 'ickly '.
           05  FILLER         pic X(6)   value 'etten '.
           05  FILLER         pic X(6)   value 'und   '.
           05  FILLER         pic X(6)   value 'etto  '.
           05  FILLER         pic X(6)   value 'old   '.
           05  FILLER         pic X(6)   value 'elder '.
           05  FILLER         pic X(6)   value 'ito   '.
           05  FILLER         pic X(6)   value 'elly  '.
           05  FILLER         pic X(6)   value 'ard   '.
           05  FILLER         pic X(6)   value 'icle  '.
           05  FILLER         pic X(6)   value 'ooney '.
           05  FILLER         pic X(6)   value 'eans  '.
           05  FILLER         pic X(6)   value 'ately '.
           05  FILLER         pic X(6)   value 'arnt  '.
           05  FILLER         pic X(6)   value 'ily   '.
       01  LNAME-S1-01        redefines LNAME-S1-DATA.
           05  LNAME-S1       pic X(6)
                              occurs 18 times.
       01  LNAME-S1-LIMIT     pic 9(3)    value 18.
       01  LN1-IDX            pic 9(3)    value 1.

       01  LNAME-S2-DATA.
           05  FILLER         pic X(6)   value 'ly    '.
           05  FILLER         pic X(6)   value 'son   '.
           05  FILLER         pic X(6)   value 'stein '.
           05  FILLER         pic X(6)   value 'man   '.
           05  FILLER         pic X(6)   value 'dan   '.
           05  FILLER         pic X(6)   value 'ney   '.
           05  FILLER         pic X(6)   value 'witz  '.
           05  FILLER         pic X(6)   value 'ford  '.
           05  FILLER         pic X(6)   value 'sis   '.
           05  FILLER         pic X(6)   value 'ter   '.
           05  FILLER         pic X(6)   value 'ski   '.
           05  FILLER         pic X(6)   value 'hara  '.
           05  FILLER         pic X(6)   value 'polis '.
           05  FILLER         pic X(6)   value 'ber   '.
           05  FILLER         pic X(6)   value '      '.
           05  FILLER         pic X(6)   value 'kard  '.
           05  FILLER         pic X(6)   value 'wood  '.
           05  FILLER         pic X(6)   value 'ket   '.
           05  FILLER         pic X(6)   value 'to    '.
           05  FILLER         pic X(6)   value 'dro   '.
           05  FILLER         pic X(6)   value 'lez   '.
           05  FILLER         pic X(6)   value 'lino  '.
           05  FILLER         pic X(6)   value 'ton   '.
           05  FILLER         pic X(6)   value 'lund  '.
           05  FILLER         pic X(6)   value 'nold  '.
           05  FILLER         pic X(6)   value 'rel   '.
           05  FILLER         pic X(6)   value 'lard  '.
           05  FILLER         pic X(6)   value 'reck  '.
           05  FILLER         pic X(6)   value 'cardi '.
           05  FILLER         pic X(6)   value 'sito  '.
           05  FILLER         pic X(6)   value 'lani  '.
           05  FILLER         pic X(6)   value 'berg  '.
       01  LNAME-S2-01        redefines LNAME-S2-DATA.
           05  LNAME-S2       pic X(6)
                              occurs 32 times.
       01  LNAME-S2-LIMIT     pic 9(3)    value 32.
       01  LN2-IDX            pic 9(3)    value 1.

       01  ADDR1-SUFFIX-DATA.
           05  FILLER         pic X(10)  value ' Road     '.
           05  FILLER         pic X(10)  value ' Avenue   '.
           05  FILLER         pic X(10)  value ' Blvd     '.
           05  FILLER         pic X(10)  value ' Street   '.
           05  FILLER         pic X(10)  value ' Court    '.
           05  FILLER         pic X(10)  value ' Circle   '.
           05  FILLER         pic X(10)  value ' Plaza    '.
           05  FILLER         pic X(10)  value ' Ave.     '.
           05  FILLER         pic X(10)  value ' Lane     '.
           05  FILLER         pic X(10)  value ' Highway  '.
           05  FILLER         pic X(10)  value ' St.      '.
           05  FILLER         pic X(10)  value ' Way      '.
           05  FILLER         pic X(10)  value '          '.
           05  FILLER         pic X(10)  value ' Boulevard'.
           05  FILLER         pic X(10)  value '          '.
           05  FILLER         pic X(10)  value ' St.      '.
           05  FILLER         pic X(10)  value ' Drive    '.
           05  FILLER         pic X(10)  value '          '.
           05  FILLER         pic X(10)  value ' St.      '.
           05  FILLER         pic X(10)  value '          '.
           05  FILLER         pic X(10)  value '          '.
           05  FILLER         pic X(10)  value ' Parkway  '.
           05  FILLER         pic X(10)  value ' Terrace  '.
           05  FILLER         pic X(10)  value ' Street   '.
           05  FILLER         pic X(10)  value '          '.

       01  ADDR1-SUFFIX-01    redefines ADDR1-SUFFIX-DATA.
           05  ADDR1-SUFFIX   pic X(10)
                              occurs 25 times.
       01  ADDR1-SUFFIX-LIMIT pic 9(3)   value 25.

       01  ADDR1-S2-DATA.
           05  FILLER         pic X(10)  value 'ly        '.
           05  FILLER         pic X(10)  value 'shaw      '.
           05  FILLER         pic X(10)  value 'wood      '.
           05  FILLER         pic X(10)  value 'bator     '.
           05  FILLER         pic X(10)  value 'tie       '.
           05  FILLER         pic X(10)  value 'gle       '.
           05  FILLER         pic X(10)  value 'non       '.
           05  FILLER         pic X(10)  value 'land      '.
           05  FILLER         pic X(10)  value 'vier      '.
           05  FILLER         pic X(10)  value 'lita      '.
           05  FILLER         pic X(10)  value 'lis       '.
           05  FILLER         pic X(10)  value 'canly     '.
           05  FILLER         pic X(10)  value 'sota      '.
           05  FILLER         pic X(10)  value 'veda      '.
           05  FILLER         pic X(10)  value 'haven     '.
           05  FILLER         pic X(10)  value 'ncho      '.
           05  FILLER         pic X(10)  value 'tree      '.
           05  FILLER         pic X(10)  value 'dero      '.
           05  FILLER         pic X(10)  value 'kalee     '.
           05  FILLER         pic X(10)  value 'ban       '.
           05  FILLER         pic X(10)  value 'ria       '.
           05  FILLER         pic X(10)  value 'dosa      '.
           05  FILLER         pic X(10)  value 'mons      '.
           05  FILLER         pic X(10)  value 'more      '.
           05  FILLER         pic X(10)  value 'bana      '.
           05  FILLER         pic X(10)  value 'sedea     '.
           05  FILLER         pic X(10)  value 'chenlie   '.
           05  FILLER         pic X(10)  value 'ladaro    '.

       01  ADDR1-S2-01        redefines ADDR1-S2-DATA.
           05  ADDR1-S2       pic X(10)
                              occurs 28 times.
       01  ADDR1-S2-LIMIT     pic 9(3)   value 28.
       01  S2-IDX             pic 9(3)   value 1.

       01  FIRST-S1-DATA.
           05  FILLER         pic X(10)  value 'ly        '.
           05  FILLER         pic X(10)  value 'bra       '.
           05  FILLER         pic X(10)  value 'cy        '.
           05  FILLER         pic X(10)  value 'nald      '.
           05  FILLER         pic X(10)  value 'tie       '.
           05  FILLER         pic X(10)  value 'ry        '.
           05  FILLER         pic X(10)  value 'mond      '.
      *
       01  FIRST-S1-01        redefines FIRST-S1-DATA.
           05  FIRST-S1       pic X(10)
                              occurs 7 times.
       01  FIRST-S1-LIMIT     pic 9(3)   value 7.
       01  FS1-IDX            pic 9(3)   value 1.

       01  FIRST-S2-DATA.
           05  FILLER         pic X(10)  value 'alee      '.
           05  FILLER         pic X(10)  value 'ita       '.
           05  FILLER         pic X(10)  value 'eo        '.
           05  FILLER         pic X(10)  value 'elyn      '.
           05  FILLER         pic X(10)  value 'ancy      '.
           05  FILLER         pic X(10)  value 'anna      '.
           05  FILLER         pic X(10)  value 'ese       '.
           05  FILLER         pic X(10)  value 'ulag      '.
      *
       01  FIRST-S2-01        redefines FIRST-S2-DATA.
           05  FIRST-S2       pic X(10)
                              occurs 8 times.
       01  FIRST-S2-LIMIT     pic 9(3)   value 8.
       01  FS2-IDX            pic 9(3)   value 1.


       01  MIXED-NUMBERS       pic X(10)  value '1736925840'.
       01  MN-PTR              pic 9(3)   value 1.

       01  OLD-100             pic 99     value 0.
       01  NEW-100             pic 99     value 0.
       01  DOUBLE-DIGITS       pic X(20)  value '81072639547124908763'.
       01  DD-PTR              pic 9(3)   value 0.

       01  WORK-02-A-C.
           05  WORK-02-N-C     pic 99     COMP value 0.

       01  WORK-02-A.
           05  WORK-02-N       pic 99     value 0.
       01  WORK-05-A.
           05  WORK-05-N       pic 9(5)   value 0.

       01  PC-WRK-1.
           05  PC-WRK-1-LEFT   pic  9(4)  COMP VALUE 0.
           05  PC-WRK-1-RITE   pic  9(4)  COMP VALUE 0.
       01  PC-WRK-2            redefines PC-WRK-1
                               pic  9(9).

       01  TOTAL-UPDATES.
           05  UPD-COUNT        pic 9(9)    value 0.
           05  FILLER           pic X       value SPACE.
           05  FILLER pic X(28) value 'Records have been updated...'.

       01  TOTAL-ADDS.
           05  ADD-COUNT        pic 9(9)    value 0.
           05  FILLER           pic X       value SPACE.
           05  FILLER pic X(28) value 'Records have been Added...  '.

       01  BEHAVIOR-FLAGS.
           05  BF-FNAME        pic X       value 'F'.
           05  BF-LNAME        pic X       value 'F'.
           05  BF-CITY         pic X       value 'F'.
           05  BF-SADR         pic X       value 'F'.
           05  BF-KEY-BYTE-1   pic X       value '0'.
           05  BF-FILE-MODE    pic X       value '0'.
           05  BF-07           pic X       value '0'.
           05  BF-08           pic X       value '0'.

      *****************************************************************
       LINKAGE SECTION.
       COPY PASSOBB1.

      *****************************************************************
       PROCEDURE DIVISION USING OBB1-PASS-AREA.
           move OBB1-BEHAVIOR-FLAGS to BEHAVIOR-FLAGS
           if  FLIP-FLOP = '0'
               move '1' to FLIP-FLOP
           else
               move '0' to FLIP-FLOP
           end-if

           evaluate OBB1-REQUEST
             when 'G' perform GET-ALL
             when 'C' perform CLOSE-ALL
           end-evaluate

           GOBACK.

      *****************************************************************
       GET-ALL.
           perform INITIALIZE-CUSTOMER-RECORD

           perform ROLLING-FIVE-DIGITS

           perform DO-LAST-NAME
           perform DO-FIRST-NAME
           perform DO-ADDR1
           perform DO-CITY-STATE-ZIP
           exit.

      *****************************************************************
       CLOSE-ALL.
           if  FNAMEM01-OPEN-FLAG = 'O'
               perform FNAMEM01-CLOSE
           end-if
           if  FNAMEF01-OPEN-FLAG = 'O'
               perform FNAMEF01-CLOSE
           end-if
           if  LASTNAME-OPEN-FLAG = 'O'
               perform LASTNAME-CLOSE
           end-if
           if  POSTCODE-OPEN-FLAG = 'O'
               perform POSTCODE-CLOSE
           end-if
           if  STREET01-OPEN-FLAG = 'O'
               perform STREET01-CLOSE
           end-if
           exit.

      *****************************************************************
      * The following routines are in alphabetic sequence.            *
      *****************************************************************
       INITIALIZE-CUSTOMER-RECORD.
           move all SPACES to OBB1-DATA
           initialize OBB1-DATA
           exit.

      *****************************************************************
       DO-LAST-NAME.
           if  BF-LNAME = 'F'
               perform DO-LAST-NAME-FIND
           else
               perform DO-LAST-NAME-GENR
           end-if
           exit.

      *---------------------------------------------------------------*
       DO-LAST-NAME-FIND.
           move SPACES to OBB1-LAST-NAME
           if  LASTNAME-OPEN-FLAG not = 'O'
               perform LASTNAME-OPEN
           end-if

           perform LASTNAME-READ

           if  APPL-EOF
               perform LASTNAME-CLOSE
               perform LASTNAME-OPEN
               perform LASTNAME-READ
           end-if

           if  LASTNAME-STATUS = '00'
               move LASTNAME-DATA-01(7:26) to OBB1-LAST-NAME
           end-if

           exit.

      *---------------------------------------------------------------*
       DO-LAST-NAME-GENR.
           move SPACES to OBB1-LAST-NAME
           move CONSTANTS-UPPER(CU-1:1) to OBB1-LAST-NAME(1:1)
           perform CU-1-INCR
           move VOWELS-LOWER(VL-1:1) to OBB1-LAST-NAME(2:1)
           perform VL-1-INCR
           move CONSTANTS-LOWER(CL-2:1) to OBB1-LAST-NAME(3:1)
           perform CL-2-DECR
           move VOWELS-LOWER(VL-1:1) to OBB1-LAST-NAME(4:1)
           perform VL-1-INCR
           if  FLIP-FLOP = '1'
               move CONSTANTS-LOWER(CL-1:1) to OBB1-LAST-NAME(5:1)
               perform CL-1-INCR
               if  LN1-IDX not < LNAME-S1-LIMIT
                   add 1 to ZERO giving LN1-IDX
               else
                   add 1 to LN1-IDX
               end-if
               inspect OBB1-LAST-NAME
                 replacing first '      ' by LNAME-S1(LN1-IDX)
           else
               if  LN2-IDX not < LNAME-S2-LIMIT
                   add 1 to ZERO giving LN2-IDX
               else
                   add 1 to LN2-IDX
               end-if
               inspect OBB1-LAST-NAME
                 replacing first '      ' by LNAME-S2(LN2-IDX)
           end-if
           exit.

      *****************************************************************
       DO-FIRST-NAME.
           if  BF-FNAME = 'F'
               if  FLIP-FLOP = 0
                   perform DO-FIRST-NAME-FIND-FEMALE
               else
                   perform DO-FIRST-NAME-FIND-MALE
               end-if
           else
               perform DO-FIRST-NAME-GENR
           end-if
           exit.

      *---------------------------------------------------------------*
       DO-FIRST-NAME-FIND-MALE.
           move SPACES to OBB1-FIRST-NAME
           if  FNAMEM01-OPEN-FLAG not = 'O'
               perform FNAMEM01-OPEN
           end-if

           perform FNAMEM01-READ

           if  APPL-EOF
               perform FNAMEM01-CLOSE
               perform FNAMEM01-OPEN
               perform FNAMEM01-READ
           end-if

           if  FNAMEM01-STATUS = '00'
               move FNAMEM01-DATA-01(7:20) to OBB1-FIRST-NAME
           end-if

           exit.

      *---------------------------------------------------------------*
       DO-FIRST-NAME-FIND-FEMALE.
           move SPACES to OBB1-FIRST-NAME
           if  FNAMEF01-OPEN-FLAG not = 'O'
               perform FNAMEF01-OPEN
           end-if

           perform FNAMEF01-READ

           if  APPL-EOF
               perform FNAMEF01-CLOSE
               perform FNAMEF01-OPEN
               perform FNAMEF01-READ
           end-if

           if  FNAMEF01-STATUS = '00'
               move FNAMEF01-DATA-01(7:20) to OBB1-FIRST-NAME
           end-if

           exit.

      *---------------------------------------------------------------*
       DO-FIRST-NAME-GENR.
           move SPACES to OBB1-FIRST-NAME
           move CONSTANTS-UPPER(CU-1:1) to OBB1-FIRST-NAME(1:1)
           perform CU-1-INCR
           move VOWELS-LOWER(VL-1:1) to OBB1-FIRST-NAME(2:1)
           perform VL-1-INCR
           move CONSTANTS-LOWER(CL-2:1) to OBB1-FIRST-NAME(3:1)
           perform CL-2-DECR
           move VOWELS-LOWER(VL-1:1) to OBB1-FIRST-NAME(4:1)
           perform VL-1-INCR
           if  FLIP-FLOP = '1'
               move CONSTANTS-LOWER(CL-1:1) to OBB1-FIRST-NAME(5:1)
               perform CL-1-INCR
               if  FS2-IDX not < FIRST-S2-LIMIT
                   add 1 to ZERO giving FS2-IDX
               else
                   add 1 to FS2-IDX
               end-if
               inspect OBB1-FIRST-NAME
                 replacing first '          ' by FIRST-S2(FS2-IDX)
           else
               if  FS1-IDX not < FIRST-S1-LIMIT
                   add 1 to ZERO giving FS1-IDX
               else
                   add 1 to FS1-IDX
               end-if
               inspect OBB1-FIRST-NAME
                 replacing first '          ' by FIRST-S1(FS1-IDX)
           end-if
           exit.

      *****************************************************************
       DO-CITY-STATE-ZIP.
           if  BF-CITY = 'F'
               perform DO-CITY-STATE-ZIP-FIND
           else
               perform DO-CITY-STATE-ZIP-GENR
           end-if
           exit.

      *---------------------------------------------------------------*
       DO-CITY-STATE-ZIP-FIND.
           move SPACES to OBB1-CITY
           move SPACES to OBB1-STATE
           move SPACES to OBB1-POSTAL-CODE
           if  POSTCODE-OPEN-FLAG not = 'O'
               perform POSTCODE-OPEN
           end-if

           perform POSTCODE-READ

           if  APPL-EOF
               perform POSTCODE-CLOSE
               perform POSTCODE-OPEN
               perform POSTCODE-READ
           end-if

           if  POSTCODE-STATUS = '00'
               move POSTCODE-ZIP-05  to OBB1-POSTAL-CODE
               move POSTCODE-CITY    to OBB1-CITY
               move POSTCODE-STATE   to OBB1-STATE
           end-if

           exit.

      *---------------------------------------------------------------*
       DO-CITY-STATE-ZIP-GENR.
           move CAPITOL-TABLE(STATE-IDX) to OBB1-CITY
           move STATE-TABLE(STATE-IDX) to OBB1-STATE
           if  STATE-IDX < 50
               add 1 to STATE-IDX
           else
               add 1 to ZERO giving STATE-IDX
           end-if
           move WORK-05-A(3:1) to OBB1-POSTAL-CODE(1:1)
           move WORK-05-A(5:1) to OBB1-POSTAL-CODE(2:1)
           move WORK-05-A(1:1) to OBB1-POSTAL-CODE(3:1)
           move WORK-05-A(4:1) to OBB1-POSTAL-CODE(4:1)
           move WORK-05-A(2:1) to OBB1-POSTAL-CODE(5:1)
           move '-'            to OBB1-POSTAL-CODE(6:1)
           move FOUR-DIGITS    to OBB1-POSTAL-CODE(7:4)
           add 1 to FOUR-DIGITS
           exit.

      *****************************************************************
       DO-ADDR1.
           move SPACES to OBB1-ADDRESS-1
           move ADDR-NUMBER to OBB1-ADDRESS-1
           if  BF-SADR = 'F'
               perform DO-ADDR1-FIND
           else
               perform DO-ADDR1-GENR
           end-if
           exit.
      *---------------------------------------------------------------*
       DO-ADDR1-FIND.
           if  STREET01-OPEN-FLAG not = 'O'
               perform STREET01-OPEN
           end-if

           perform STREET01-READ

           if  APPL-EOF
               perform STREET01-CLOSE
               perform STREET01-OPEN
               perform STREET01-READ
           end-if

           if  STREET01-STATUS = '00'
               add NBR-1-VALUE to 2 giving PTR-2
               move ADDR-NUMBER(1:NBR-1-VALUE)
                                       to OBB1-ADDRESS-1(1:NBR-1-VALUE)
               move STREET01-DATA-01(7:40)
                                       to OBB1-ADDRESS-1(PTR-2:40)
           end-if

           exit.

      *---------------------------------------------------------------*
       DO-ADDR1-GENR.
      *    Do the street name . . .
           move CONSTANTS-UPPER(CU-2:1) to OBB1-ADDRESS-1(PTR-2:1)
           perform CU-2-DECR
           add 1 to PTR-2

           move VOWELS-LOWER(VL-2:1) to OBB1-ADDRESS-1(PTR-2:1)
           perform VL-2-INCR

           if  S2-IDX not < ADDR1-S2-LIMIT
               add 1 to ZERO giving S2-IDX
           else
               add 1 to S2-IDX
           end-if
           inspect OBB1-ADDRESS-1
             replacing first '          ' by ADDR1-S2(S2-IDX)

           if  IDX-2 not < ADDR1-SUFFIX-LIMIT
               add 1 to ZERO giving IDX-2
           else
               add 1 to IDX-2
           end-if
           inspect OBB1-ADDRESS-1
             replacing first '          ' by ADDR1-SUFFIX(IDX-2)

           exit.

      *****************************************************************
       CU-1-INCR.
           if  CU-1 < 21
               add 1 to CU-1
           else
               add 1 to ZERO giving CU-1
           end-if
           exit.

       CU-2-INCR.
           if  CU-2 < 21
               add 1 to CU-2
           else
               add 1 to ZERO giving CU-2
           end-if
           exit.

       CL-1-INCR.
           if  CL-1 < 21
               add 1 to CL-1
           else
               add 1 to ZERO giving CL-1
           end-if
           exit.

       VL-1-INCR.
           if  VL-1 < 5
               add 1 to VL-1
           else
               add 1 to ZERO giving VL-1
           end-if
           exit.

       VL-2-INCR.
           if  VL-2 < 5
               add 1 to VL-2
           else
               add 1 to ZERO giving VL-2
           end-if
           exit.

       MN-PTR-INCR.
           if  MN-PTR < 10
               add 1 to MN-PTR
           else
               add 1 to ZERO giving MN-PTR
           end-if
           exit.

       CU-2-DECR.
           if  CU-2 > 1
               subtract 1 from CU-2
           else
               add 21 to ZERO giving CU-2
           end-if
           exit.


       CL-2-DECR.
           if  CL-2 > 1
               subtract 1 from CL-2
           else
               add 21 to ZERO giving CL-2
           end-if
           exit.

      *****************************************************************
       ROLLING-FIVE-DIGITS.
           if  PTR-S > 18
               add 1 to ZERO giving PTR-S
           end-if
           move SPACES to ADDR-NUMBER
           move SIZE-TABLE(PTR-S:1)  to NBR-1-ALPHA
           evaluate NBR-1-VALUE
             when 2
               move TEN-DIGITS(6:1) to ONE-DIGIT
               move TEN-DIGITS(4:1) to TEN-DIGITS(6:1)
               move TEN-DIGITS(9:1) to TEN-DIGITS(4:1)
               move ONE-DIGIT       to TEN-DIGITS(9:1)
             when 3
               move TEN-DIGITS(2:1) to ONE-DIGIT
               move TEN-DIGITS(5:1) to TEN-DIGITS(2:1)
               move TEN-DIGITS(8:1) to TEN-DIGITS(5:1)
               move ONE-DIGIT       to TEN-DIGITS(8:1)
             when 4
               move TEN-DIGITS(1:1)  to ONE-DIGIT
               move TEN-DIGITS(2:1)  to TEN-DIGITS(1:1)
               move TEN-DIGITS(3:1)  to TEN-DIGITS(2:1)
               move TEN-DIGITS(4:1)  to TEN-DIGITS(3:1)
               move TEN-DIGITS(5:1)  to TEN-DIGITS(4:1)
               move TEN-DIGITS(6:1)  to TEN-DIGITS(5:1)
               move TEN-DIGITS(7:1)  to TEN-DIGITS(6:1)
               move TEN-DIGITS(8:1)  to TEN-DIGITS(7:1)
               move TEN-DIGITS(9:1)  to TEN-DIGITS(8:1)
               move TEN-DIGITS(10:1) to TEN-DIGITS(9:1)
               move ONE-DIGIT        to TEN-DIGITS(10:1)
             when other
               move TEN-DIGITS(3:1) to ONE-DIGIT
               move TEN-DIGITS(1:1) to TEN-DIGITS(3:1)
               move TEN-DIGITS(7:1) to TEN-DIGITS(1:1)
               move ONE-DIGIT       to TEN-DIGITS(7:1)
           end-evaluate
           move TEN-DIGITS(1:NBR-1-VALUE) to ADDR-NUMBER
           if  ADDR-NUMBER(1:1) = '0'
               if  TEN-DIGITS(10:1) = '0'
                   move TEN-DIGITS(9:1) to ADDR-NUMBER(1:1)
               else
                   move TEN-DIGITS(10:1) to ADDR-NUMBER(1:1)
               end-if
           end-if
           add 1 to PTR-S
           exit.

       OLD-STUFF.
           add 1 to ZERO giving PTR-2
           move SPACES to ADDR-NUMBER
           if  MN-PTR not < 10
               add 1 to ZERO giving MN-PTR
           else
               add 1 to MN-PTR
           end-if
           if  MIXED-NUMBERS(MN-PTR:1) not = '0'
               move MIXED-NUMBERS(MN-PTR:1) to ADDR-NUMBER(PTR-2:1)
               move MIXED-NUMBERS(MN-PTR:1) to WORK-05-A(PTR-2:1)
               add 1 to PTR-2
           end-if

           if  NEW-100 = OLD-100
               if  DD-PTR < 19
               and DD-PTR > 0
                   add 2 to DD-PTR
               else
                  add 1 to ZERO giving DD-PTR
               end-if
               move DOUBLE-DIGITS(DD-PTR:2) to WORK-02-A
               add WORK-02-N to NEW-100
           else
               move NEW-100 to OLD-100
           end-if

           if   NEW-100 > 9
                if  NEW-100 > 60
                    move NEW-100 to ADDR-NUMBER(PTR-2:2)
                    move OLD-100(2:1) to ADDR-NUMBER(PTR-2 + 2:1)
                    move NEW-100 to WORK-05-A(PTR-2:2)
                    add 4 to PTR-2
                else
                    move NEW-100 to ADDR-NUMBER(PTR-2:2)
                    move NEW-100 to WORK-05-A(PTR-2:2)
                    add 3 to PTR-2
                end-if
           else
                if  NEW-100 > 0
                    move NEW-100(2:1) to ADDR-NUMBER(PTR-2:2)
                    move NEW-100(2:1) to WORK-05-A(PTR-2:2)
                    add 2 to PTR-2
                end-if
           end-if
           if PTR-2 = 2
              add 1 to PTR-2
           end-if
           inspect WORK-05-A replacing first '  '
                             by DOUBLE-DIGITS(DD-PTR:2)
           inspect WORK-05-A replacing first ' '
                             by  MIXED-NUMBERS(MN-PTR:1)
           add 1 to MN-PTR
           inspect WORK-05-A replacing first ' '
                           by  MIXED-NUMBERS(MN-PTR:1)

           if PTR-2 = 1
              if  MN-PTR not < 11
                  add 1 to ZERO giving MN-PTR
              end-if
              if MIXED-NUMBERS(MN-PTR:1) = '0'
                 perform MN-PTR-INCR
              end-if
              move MIXED-NUMBERS(MN-PTR:1) to ADDR-NUMBER(PTR-2:1)
              move MIXED-NUMBERS(MN-PTR:1) to WORK-05-A(PTR-2:1)
              add 1 to PTR-2
              perform 3 times
                perform MN-PTR-INCR
                move MIXED-NUMBERS(MN-PTR:1) to ADDR-NUMBER(PTR-2:1)
                move MIXED-NUMBERS(MN-PTR:1) to WORK-05-A(PTR-2:1)
                add 1 to PTR-2
              end-perform
              add 1 to PTR-2
           end-if

           exit.

      *****************************************************************
      * I/O Routines for the INPUT File...                            *
      *****************************************************************
       FNAMEM01-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close FNAMEM01-FILE
           if  FNAMEM01-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CLOSE Failure with FNAMEM01' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move FNAMEM01-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       FNAMEM01-READ.
           read FNAMEM01-FILE
           if  FNAMEM01-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  FNAMEM01-STATUS = '10'
               or  FNAMEM01-STATUS = '23'
               or  FNAMEM01-STATUS = '46'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if
           if  APPL-AOK
               CONTINUE
           else
               if  APPL-EOF
                   move 'Y' to FNAMEM01-EOF
               else
                   move 'READ Failure with FNAMEM01' to MESSAGE-TEXT
                   perform Z-DISPLAY-MESSAGE-TEXT
                   move FNAMEM01-STATUS to IO-STATUS
                   perform Z-DISPLAY-IO-STATUS
                   perform Z-ABEND-PROGRAM
               end-if
           end-if
           exit.
      *---------------------------------------------------------------*
       FNAMEM01-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open input FNAMEM01-FILE
           if  FNAMEM01-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to FNAMEM01-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'OPEN Failure with FNAMEM01' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move FNAMEM01-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
       FNAMEF01-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close FNAMEF01-FILE
           if  FNAMEF01-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CLOSE Failure with FNAMEF01' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move FNAMEF01-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       FNAMEF01-READ.
           read FNAMEF01-FILE
           if  FNAMEF01-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  FNAMEF01-STATUS = '10'
               or  FNAMEF01-STATUS = '23'
               or  FNAMEF01-STATUS = '46'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if
           if  APPL-AOK
               CONTINUE
           else
               if  APPL-EOF
                   move 'Y' to FNAMEF01-EOF
               else
                   move 'READ Failure with FNAMEF01' to MESSAGE-TEXT
                   perform Z-DISPLAY-MESSAGE-TEXT
                   move FNAMEF01-STATUS to IO-STATUS
                   perform Z-DISPLAY-IO-STATUS
                   perform Z-ABEND-PROGRAM
               end-if
           end-if
           exit.
      *---------------------------------------------------------------*
       FNAMEF01-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open input FNAMEF01-FILE
           if  FNAMEF01-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to FNAMEF01-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'OPEN Failure with FNAMEF01' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move FNAMEF01-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.


      *****************************************************************
      * I/O Routines for the INPUT File...                            *
      *****************************************************************
       LASTNAME-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close LASTNAME-FILE
           if  LASTNAME-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CLOSE Failure with LASTNAME' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move LASTNAME-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       LASTNAME-READ.
           read LASTNAME-FILE
           if  LASTNAME-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  LASTNAME-STATUS = '10'
               or  LASTNAME-STATUS = '23'
               or  LASTNAME-STATUS = '46'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if
           if  APPL-AOK
               CONTINUE
           else
               if  APPL-EOF
                   move 'Y' to LASTNAME-EOF
               else
                   move 'READ Failure with LASTNAME' to MESSAGE-TEXT
                   perform Z-DISPLAY-MESSAGE-TEXT
                   move LASTNAME-STATUS to IO-STATUS
                   perform Z-DISPLAY-IO-STATUS
                   perform Z-ABEND-PROGRAM
               end-if
           end-if
           exit.
      *---------------------------------------------------------------*
       LASTNAME-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open input LASTNAME-FILE
           if  LASTNAME-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to LASTNAME-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'OPEN Failure with LASTNAME' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move LASTNAME-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * I/O Routines for the INPUT File...                            *
      *****************************************************************
       POSTCODE-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close POSTCODE-FILE
           if  POSTCODE-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CLOSE Failure with POSTCODE' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move POSTCODE-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       POSTCODE-READ.
           read POSTCODE-FILE
           if  POSTCODE-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  POSTCODE-STATUS = '10'
               or  POSTCODE-STATUS = '23'
               or  POSTCODE-STATUS = '46'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if
           if  APPL-AOK
               CONTINUE
           else
               if  APPL-EOF
                   move 'Y' to POSTCODE-EOF
               else
                   move 'READ Failure with POSTCODE' to MESSAGE-TEXT
                   perform Z-DISPLAY-MESSAGE-TEXT
                   move POSTCODE-STATUS to IO-STATUS
                   perform Z-DISPLAY-IO-STATUS
                   perform Z-ABEND-PROGRAM
               end-if
           end-if
           exit.
      *---------------------------------------------------------------*
       POSTCODE-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open input POSTCODE-FILE
           if  POSTCODE-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to POSTCODE-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'OPEN Failure with POSTCODE' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move POSTCODE-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * I/O Routines for the INPUT File...                            *
      *****************************************************************
       STREET01-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close STREET01-FILE
           if  STREET01-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CLOSE Failure with STREET01' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move STREET01-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       STREET01-READ.
           read STREET01-FILE
           if  STREET01-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  STREET01-STATUS = '10'
               or  STREET01-STATUS = '23'
               or  STREET01-STATUS = '46'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if
           if  APPL-AOK
               CONTINUE
           else
               if  APPL-EOF
                   move 'Y' to STREET01-EOF
               else
                   move 'READ Failure with STREET01' to MESSAGE-TEXT
                   perform Z-DISPLAY-MESSAGE-TEXT
                   move STREET01-STATUS to IO-STATUS
                   perform Z-DISPLAY-IO-STATUS
                   perform Z-ABEND-PROGRAM
               end-if
           end-if
           exit.
      *---------------------------------------------------------------*
       STREET01-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open input STREET01-FILE
           if  STREET01-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to STREET01-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'OPEN Failure with STREET01' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move STREET01-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.


      *****************************************************************
      * The following Z-Routines perform administrative tasks         *
      * for this program.                                             *
      *****************************************************************
      *
      *****************************************************************
      * ABEND the program, post a message to the console and issue    *
      * a STOP RUN.                                                   *
      *****************************************************************
       Z-ABEND-PROGRAM.
           if  MESSAGE-TEXT not = SPACES
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           move 'DATOBFC1 PROGRAM-IS-ABENDING...'  to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT
           add 12 to ZERO giving RETURN-CODE
           STOP RUN.

      *****************************************************************
       Z-DISPLAY-MESSAGE-TEXT.
           if MESSAGE-TEXT-2 = SPACES
               display MESSAGE-BUFFER(1:79) upon console
           else
               display MESSAGE-BUFFER upon console
           end-if
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
      * Display the file status bytes. This routine will display as   *
      * four digits. If the full two byte file status is numeric it   *
      * will display as 00nn. If the 1st byte is a numeric nine (9)   *
      * the second byte will be treated as a binary number and will   *
      * display as 9nnn.                                              *
      *****************************************************************
       Z-DISPLAY-IO-STATUS.
           if  IO-STATUS not NUMERIC
           or  IO-STAT1 = '9'
               move IO-STAT1 to IO-STATUS-04(1:1)
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move IO-STAT2 to TWO-BYTES-RIGHT
               add TWO-BYTES-BINARY to ZERO giving IO-STATUS-0403
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-04 to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           else
               move '0000' to IO-STATUS-04
               move IO-STATUS to IO-STATUS-04(3:2)
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-04 to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           exit.

      *****************************************************************
      *      This example is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
