@echo OFF
rem  * *******************************************************************
rem  *               OBFUPDE1.CMD - a Windows Command File               *
rem  *         This program is provided by SimoTime Technologies         *
rem  *           (C) Copyright 1987-2019 All Rights Reserved             *
rem  *             Web Site URL:   http://www.simotime.com               *
rem  *                   e-mail:   helpdesk@simotime.com                 *
rem  * *******************************************************************
rem  *
rem  * Text   - Create a Customer Master File.
rem  * Author - SimoTime Technologies
rem  * Date   - January 24, 1996
rem  *
rem  * The job will read various data files to get First and Last name
rem  * and City, State and Postal Code information. This information
rem  * is then used to create a Customer Master files.
rem  *
rem  * This program uses a Random, ADD/UPDATE methodology. Therefore,
rem  * the records being added to the file do not need to be in
rem  * sequence by the record key.
rem  *
rem  * *******************************************************************
rem  * Step 1, Set the Environment...
rem  *
     set CmdName=OBFUPDE1
     call ..\Env1BASE
     if "%SYSLOG%" == "" set syslog=c:\SimoLIBR\LOGS\SimoTime.LOG
rem  *
     call SimoNOTE "*******************************************************%CmdName%"
     call SimoNOTE "Starting JobName %CmdName%"
:DeleteQSAM
     call SimoNOTE "Identify JobStep DeleteQSAM"
     set FNAMEM01=%BASECAT%\APPL\SIMOTIME.DATA.FNAMEM01.DAT
     set FNAMEF01=%BASECAT%\APPL\SIMOTIME.DATA.FNAMEF01.DAT
     set LASTNAME=%BASECAT%\APPL\SIMOTIME.DATA.LASTNAME.DAT
     set POSTCODE=%BASECAT%\APPL\SIMOTIME.DATA.POSTCODE.DAT
     set STREET01=%BASECAT%\APPL\SIMOTIME.DATA.STREET01.DAT
     set OBF1CUST=%BASECAT%\Wrk1\SIMOTIME.DATA.OBF1CUST.DAT
     set OBFCTL80=%BASECAT%\Asc1\SIMOTIME.DATA.OBFCTL80.DAT
rem  *
     call SimoNOTE "CntlFILE=%OBFCTL80%'
     call SimoNOTE "DataMAKE=%OBF1CUST%'
rem  *
rem  * *******************************************************************
rem  * Step 2, Add new records or update existing records in the customer
rem  *         master file.
rem  *
     run OBFDATC1
     if not "%ERRORLEVEL%" == "0" set JobStatus=0010
     if not %JobStatus% == 0000 goto :EojNok
rem  *
     if exist %OBF1CUST% goto :EojAok
     set JobStatus=0020
     goto :EojNok
rem  *
rem  * *******************************************************************
rem  * End of Job Processing...
rem  *
:EojAok
     call SimoNOTE "Produced DataSet %OBF1CUST%"
     call SimoNOTE "Finished JobName %CmdName%, Job Status is %JobStatus%"
     goto :End
:EojNok
     call SimoNOTE "ABENDING JobName %CmdName%, Job Status is %JobStatus%"
:End
     call SimoNOTE "Conclude SysLog is %SYSLOG%"
     if not "%1" == "nopause" pause
